// GetSizeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GetSize.h"
#include "GetSizeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define KB 1024
#define MB 1048576

/////////////////////////////////////////////////////////////////////////////
// CGetSizeDlg dialog

CGetSizeDlg::CGetSizeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetSizeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGetSizeDlg)
	m_Size = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGetSizeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGetSizeDlg)
	DDX_Text(pDX, IDC_STATIC_SIZE, m_Size);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGetSizeDlg, CDialog)
	//{{AFX_MSG_MAP(CGetSizeDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_ACTIVATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetSizeDlg message handlers

BOOL CGetSizeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	GetSize();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGetSizeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CGetSizeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// work out the directory from the command line and pass it to GetDirSize
void CGetSizeDlg::GetSize()
{
	CString path;

	if (AfxGetApp()->m_lpCmdLine[0]!='\0')
	{
		path = AfxGetApp()->m_lpCmdLine;
	}
	else
	{
		// current working directory
		path = ".";
	}

	if (path.Right(1)!="\\")
		path += "\\";
	path += "*.*";

	DWORD size = GetDirSize(path,FALSE);
	m_Size = FormatSize(size);
   UpdateData(FALSE);
}

// nicely formats the output
CString CGetSizeDlg::FormatSize(DWORD size)
{
   CString ret;
   int val;
   float fval;
   float fsize;
   fsize = float(size);

   if (size>(DWORD(MB*.95)))
   {  //greater than 95% of a megabyte
      fval = fsize/MB;
      ret.Format("Size:  %.1fMB",fval);
   }
   else
   {
      val = size/KB;
      ret.Format("Size:  %dKB",val);
   }

   return ret;
}

// recursive function that walks the directory tree calculating the size of all files
DWORD CGetSizeDlg::GetDirSize(const char *path, BOOL recurse)
{
   DWORD size(0);
   WIN32_FIND_DATA data;
   BOOL more(TRUE);
   HANDLE hnd;

   hnd = FindFirstFile(path,&data);

   while (hnd!=INVALID_HANDLE_VALUE&&more)
   {
      if (more = FindNextFile(hnd,&data))
      {
         if (data.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
         {  // It's a directory
            if ((!strcmp(data.cFileName,".")==0)&&(!strcmp(data.cFileName,"..")==0))
            {
               char fullpath[512];
               char *root;

               strcpy(fullpath,path);
               root = strrchr(fullpath,'\\');
               if (root)
               {
                  strcpy(root+1,data.cFileName);
                  strcat(root,"\\*.*");
                  size += GetDirSize(fullpath,TRUE);  // recursion
                  if (!recurse)
                  {  // Only display if not recursing, you get screwy figures otherwise
                     m_Size = FormatSize(size);
                     UpdateData(FALSE);
                  }
	            }
            }
         }
         else
         {  // It's a file, this does NOT take compressed file size into account
            size += (data.nFileSizeHigh * MAXDWORD) + data.nFileSizeLow;
         }
      }
   }
   FindClose(hnd);

   return size;
}

// Cause program to close when it loses focus
void CGetSizeDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	CDialog::OnActivate(nState, pWndOther, bMinimized);
	if (nState==WA_INACTIVE)
		CDialog::OnOK();
}
